/* Tabela LAYOUTIMP: TABELA DE LAYOUT DE IMPORTAO*/
/* Descrio: A trigger insere registros na tabela LOGOPERAVND a partir de alteraes na tabela LAYOUTIMP */
/* Objetivo: Gerar um log que vai registrar as alteraes na LAYOUTIMP,
             utilizando a tabela de Logs de Operaes do VND*/
CREATE OR REPLACE TRIGGER LOG_VND_LAYOUTIMP
AFTER DELETE OR INSERT OR UPDATE
ON LAYOUTIMP FOR EACH ROW
DECLARE
  V_DSREMOTEADDR VARCHAR2(15);
  V_DSREMOTEHOST VARCHAR2(15);
  V_DSSERVERRDM  VARCHAR2(20);
  V_DSSERVMETHOD VARCHAR2(30);
  V_DSREMOTEOPER VARCHAR2(12);
  V_DESC         VARCHAR2(500);
  V_ITPESQ       VARCHAR2(40);
  V_NMOPERADOR   VARCHAR2(40);
  V_IDTIPOOPER   VARCHAR2(1);
BEGIN
/* IDTIPOOPER - '1' - Incluso, '2' - Alterao, '3' - Excluso*/
   V_DESC       := '';
   V_ITPESQ     := '';
   V_NMOPERADOR := '';
   V_IDTIPOOPER := '';
   NMUSUARIO(V_NMOPERADOR);
   WEBTUNNING(V_DSREMOTEADDR,
              V_DSREMOTEHOST,
              V_DSSERVERRDM,
              V_DSSERVMETHOD,
              V_DSREMOTEOPER);
   IF UPDATING THEN
		IF NVL(:NEW.CDLAYOUTIMP, 'ISNULL') <> NVL(:OLD.CDLAYOUTIMP,'ISNULL') THEN
			V_DESC := 'Cd Layout Imp ' || '' || NVL(:NEW.CDLAYOUTIMP,'');
		END IF;
		IF NVL(:NEW.NMLAYOUTIMP,'ISNULL') <> NVL(:OLD.NMLAYOUTIMP,'ISNULL') THEN
			V_DESC := NVL(V_DESC,'') || ' ' || 'Nm Layout Imp ' || '' || NVL(:NEW.NMLAYOUTIMP,'');
		END IF;
		IF NVL(:NEW.IDSEPARCAMPO,'ISNULL') <> NVL(:OLD.IDSEPARCAMPO,'ISNULL') THEN
			V_DESC := NVL(V_DESC,'') || ' ' || 'Id Separador de Campo ' || '' || NVL(:NEW.IDSEPARCAMPO,'');
		END IF;
		IF NVL(:NEW.IDCARACDELIM,'ISNULL') <> NVL(:OLD.IDCARACDELIM,'ISNULL') THEN
			V_DESC := NVL(V_DESC,'') || ' ' || 'Caracter Delimitador ' || '' || NVL(:NEW.IDCARACDELIM,'');
		END IF;
		IF NVL(:NEW.IDCARACDECIM,'ISNULL') <> NVL(:OLD.IDCARACDECIM,'ISNULL') THEN
			V_DESC := NVL(V_DESC,'') || ' ' || 'Caracter Separador ' || '' || NVL(:NEW.IDCARACDECIM,'');
		END IF;
		IF NVL(:NEW.IDCARACSTRIN,'ISNULL') <> NVL(:OLD.IDCARACSTRIN,'ISNULL') THEN
			V_DESC := NVL(V_DESC,'') || ' ' || 'Caracter Delimitador St ' || '' || NVL(:NEW.IDCARACSTRIN,'');
		END IF;
		IF NVL(:NEW.IDSISTEMAIMP,'ISNULL') <> NVL(:OLD.IDSISTEMAIMP,'ISNULL') THEN
			V_DESC := NVL(V_DESC,'') || ' ' || 'Id Sis Layout' || '' || NVL(:NEW.IDSISTEMAIMP,'');
		END IF;
		IF NVL(:NEW.IDSISTEMORIG,'ISNULL') <> NVL(:OLD.IDSISTEMORIG,'ISNULL') THEN
			V_DESC := NVL(V_DESC,'') || ' ' || 'Sistema origem ' || '' || NVL(:NEW.IDSISTEMORIG,'');
		END IF;
		IF NVL(:NEW.CDFILIAL,'ISNULL') <> NVL(:OLD.CDFILIAL,'ISNULL') THEN
			V_DESC := NVL(V_DESC,'') || ' ' || 'Filial ' || '' || NVL(:NEW.CDFILIAL,'');
		END IF;
      V_ITPESQ := :NEW.CDLAYOUTIMP;
      V_IDTIPOOPER := '2';
   ELSE
      IF INSERTING THEN
      V_DESC   := 'Cd Layout Imp '           || '' || NVL(:NEW.CDLAYOUTIMP,''    )  || ' ' ||
                  'Nm Layout Imp '           || '' || NVL(:NEW.NMLAYOUTIMP,''  )    || ' ' ||
                  'Id Separador de Campo '   || '' || NVL(:NEW.IDSEPARCAMPO,''  )   || ' ' ||
                  'Caracter Delimitador '    || '' || NVL(:NEW.IDCARACDELIM,'')     || ' ' ||
                  'Caracter Separador '      || '' || NVL(:NEW.IDCARACDECIM,''  )   || ' ' ||
                  'Caracter Delimitador St ' || '' || NVL(:NEW.IDCARACSTRIN,'' )    || ' ' ||
				  'Id Sis Layout'            || '' || NVL(:NEW.IDSISTEMAIMP,''  )   || ' ' ||
                  'Sistema origem '          || '' || NVL(:NEW.IDSISTEMORIG,''  )   || ' ' ||
                  'Filial '                  || '' || NVL(:NEW.CDFILIAL,'');
      V_ITPESQ := :NEW.CDLAYOUTIMP;
         V_IDTIPOOPER := '1';
      ELSE
         IF DELETING THEN
      V_DESC   := 'Cd Layout Imp '           || '' || NVL(:OLD.CDLAYOUTIMP,''    )  || ' ' ||
                  'Nm Layout Imp '           || '' || NVL(:OLD.NMLAYOUTIMP,''  )    || ' ' ||
                  'Id Separador de Campo '   || '' || NVL(:OLD.IDSEPARCAMPO,''  )   || ' ' ||
                  'Caracter Delimitador '    || '' || NVL(:OLD.IDCARACDELIM,'')     || ' ' ||
                  'Caracter Separador '      || '' || NVL(:OLD.IDCARACDECIM,''  )   || ' ' ||
                  'Caracter Delimitador St ' || '' || NVL(:OLD.IDCARACSTRIN,'' )    || ' ' ||
				  'Id Sis Layout'            || '' || NVL(:OLD.IDSISTEMAIMP,''  )   || ' ' ||
				  'Sistema origem '          || '' || NVL(:OLD.IDSISTEMORIG,''  )   || ' ' ||
                  'Filial '                  || '' || NVL(:OLD.CDFILIAL,'');
      V_ITPESQ := :OLD.CDLAYOUTIMP;
            V_IDTIPOOPER := '3';
         END IF;
      END IF;
   END IF;
   V_DESC := SUBSTR(V_DESC, 1, 300);
   INSERT INTO LOGOPERAVND
      (NMTABELAVND,
       DTOPERACAOVND,
       NMRESPOPERVND,
       IDTIPOOPERVND,
       DSOPERACAOVND,
       CDPESQITEMVND,
       DSRDMUSUOPERVND,
       DSENDUSUOPERVND,
       DSNMUSUOPERVND,
       DSMETUSUOPERVND,
       CDORESPOPERVND,
       CDFILLOGOPERVND)
   VALUES
      ('LAYOUTIMP',
       SYSDATE,
       NVL(V_NMOPERADOR,' '),
       V_IDTIPOOPER,
       NVL(V_DESC,' '),
       V_ITPESQ,
       V_DSSERVERRDM,
       V_DSREMOTEADDR,
       V_DSREMOTEHOST,
       V_DSSERVMETHOD,
       V_DSREMOTEOPER,
       NVL(:NEW.CDFILIAL,:OLD.CDFILIAL));
END;
/

-- VERSAO --
BEGIN ATUVEROBJ('LOG_VND_LAYOUTIMP','5.20.001'); END;
/

