import { makeServer } from '@zeedhi/zeedhi-miragejs';
import { Interceptor } from '@zeedhi/core';
import adapter from '@zeedhi/axios-mirage-adapter';
import config from './config';
import { useMirage } from './use-mirage';

Interceptor.addRequestSuccess((axiosConfig) => ({ ...axiosConfig, adapter }));

const endpoint = process.env.VUE_APP_MIRAGE_END_POINT;
makeServer({ endpoint, config, logging: true });

if (!navigator.onLine) {
    useMirage();
}

window.addEventListener('online', async () => {
    useMirage(false);
});

window.addEventListener('offline', async () => {
    useMirage();
});
